/*
 *  GOL - Game of life simulation software
 *  Copyright (C) 1996 Michael Raymond Brown
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Author: Michael Raymond Brown
 *  EMail:  michael@arrakeen.demon.co.uk
 *  WWW:    http://www.arrakeen.demon.co.uk/
 *  Address:  Michael Brown
 *            Kia Ora
 *            Brook Street
 *            Great Bromley
 *            Nr Colchester
 *            Essex
 *            CO7 7HX
 *            England
 */


#ifndef _tDrawArea_h
#define _tDrawArea_h

#ifdef __GNUC__
#pragma interface
#endif


#include "GC.h"
#include "Widget.h"
#include "App.h"
#include <Xm/DrawingA.h>

class xwDrawArea : public xwWidget, public xwGC
   {protected:
	Display* display;
	Window    window;
	GC	      gc;

	inline xwDrawArea() { }
	void init();

    public:
	xwDrawArea(xwWidget* p, int x1, int y1, int x2, int y2);
	xwDrawArea(xwWidget* p, int w, int h);
	~xwDrawArea();

	Display* getDisplay();
	Window getWindow();
	GC getGC();

	void plot(int x, int y, int colour);
	int point(int x, int y);

	void line(int x1, int y1, int x2, int y2, int colour);

	void clear();
   };

#endif

