/*
 *  GOL - Game of life simulation software
 *  Copyright (C) 1996 Michael Raymond Brown
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Author: Michael Raymond Brown
 *  EMail:  michael@arrakeen.demon.co.uk
 *  WWW:    http://www.arrakeen.demon.co.uk/
 *  Address:  Michael Brown
 *            Kia Ora
 *            Brook Street
 *            Great Bromley
 *            Nr Colchester
 *            Essex
 *            CO7 7HX
 *            England
 */


#ifndef _tWindow_h
#define _tWindow_h

#ifdef __GNUC__
#pragma interface
#endif


#include "App.h"
#include "Widget.h"
#include <Xm/MainW.h>

struct xwMenu
   {const char* name;
    char    shortcut;
    int        index;
    enum {END	    = 0
	, item	    = 1
	, submenu   = 2
	, option    = 3
	, seperator = 4
	} type;
   };

class xwWindow : public xwWidget
   {private:
	Widget	    shell;
	struct Menuitem
	   {xwWindow*   me;
	    int      index;
	    Widget	 w;
	    Menuitem* next;
	   };
	Menuitem*menuitem;

	static void cbMenu(Widget, XtPointer, XtPointer);
	static void cbDestroy(Widget, XtPointer, XtPointer);
	void addMenu(Widget parent, const xwMenu*& menu);

    protected:
	inline xwWindow() { }

    public:
	xwWindow(xwApp* parent, const char* name, const xwMenu* menu = (xwMenu*)0);
	~xwWindow();

	void show();
	void addCommand(xwWidget*);

	void menuSetOption(int id, int value);
	int  menuGetOption(int id);
	void menuSetEnable(int id, int value);

	void move(int x, int y);

	void center();
   };

#endif

